'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CustomFlagIconFactory = undefined;

var _FlagIcon = require('./FlagIcon');

var _FlagIcon2 = _interopRequireDefault(_FlagIcon);

var _styles = require('../styles');

var _styles2 = _interopRequireDefault(_styles);

var _functions = require('../functions');

var _props = require('../functions/props');

var _styles3 = require('../functions/styles');

var _propTypes = require('../types/propTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var FlagIconFactory = function FlagIconFactory(React, options) {
  var computedOptions = (0, _functions.makeFlagIconOptions)(options);
  var useCssModules = computedOptions.useCssModules,
      customCodes = computedOptions.customCodes;


  var FlagIconComponent = null;

  if (useCssModules) {
    var computedStyles = (0, _functions.makeStyles)(_styles2.default, options);
    if (process.env.NODE_ENV !== 'production') {
      (0, _styles3.validateStyles)(computedStyles, computedOptions, options);
    }

    FlagIconComponent = (0, _FlagIcon2.default)(React, computedOptions, computedStyles);
  } else {
    FlagIconComponent = (0, _FlagIcon2.default)(React, computedOptions);
  }
  FlagIconComponent.displayName = 'FlagIcon';

  if (process.env.NODE_ENV !== 'production') {
    var codes = (0, _props.getCountryCodes)();

    if (customCodes) {
      codes = [].concat(_toConsumableArray(codes), _toConsumableArray(Object.keys(customCodes)));
    }

    FlagIconComponent.propTypes = (0, _propTypes.MakeFlagIconPropsType)(codes);
  }

  return FlagIconComponent;
};

exports.default = FlagIconFactory;


var CustomFlagIconFactory = function CustomFlagIconFactory(React, options) {
  return FlagIconFactory(React, options);
};
exports.CustomFlagIconFactory = CustomFlagIconFactory;