'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeClassesObject = undefined;

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _classNameToStyleName = require('../functions/classNameToStyleName');

var _classNameToStyleName2 = _interopRequireDefault(_classNameToStyleName);

var _constants = require('./constants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var makeClassesObject = exports.makeClassesObject = function makeClassesObject(props, options) {
  var _ref;

  var code = props.code,
      _props$flip = props.flip,
      flip = _props$flip === undefined ? '' : _props$flip,
      _props$size = props.size,
      size = _props$size === undefined ? '' : _props$size,
      _props$squared = props.squared,
      squared = _props$squared === undefined ? false : _props$squared,
      rotate = props.rotate,
      className = props.className,
      styleName = props.styleName;
  var themeStyles = options.themeStyles,
      useCssModules = options.useCssModules;


  return _ref = {}, _defineProperty(_ref, _constants.flagIconClassesPrefixName, true), _defineProperty(_ref, _constants.flagIconClassesPrefix + 'squared', squared), _defineProperty(_ref, '' + _constants.flagIconClassesPrefix + size, size), _defineProperty(_ref, '' + _constants.flagIconClassesPrefix + code, code), _defineProperty(_ref, _constants.flagIconClassesPrefix + 'flip-' + flip, flip), _defineProperty(_ref, _constants.flagIconClassesPrefix + 'rotate-' + (rotate || ''), rotate), _defineProperty(_ref, _constants.baseThemeStyleName, useCssModules && themeStyles && themeStyles[_constants.baseThemeStyleName]), _defineProperty(_ref, styleName || '', useCssModules && themeStyles && themeStyles[styleName]), _defineProperty(_ref, className || '', className), _ref;
};

exports.default = function (props, options, styles) {
  var useCssModules = options.useCssModules;


  var classesObject = makeClassesObject(props, options);
  var strClasses = (0, _classnames2.default)(classesObject);

  if (useCssModules) {
    var aClasses = strClasses.split(' ');
    var nClasses = aClasses.length;

    strClasses = aClasses.map(function (c, i) {
      if (props.className && i === nClasses - 1) return c;

      return (0, _classNameToStyleName2.default)(c, styles || {});
    }).join(' ');
  }
  return strClasses;
};