'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.MakeFlagIconOptionsPropType = exports.MakeFlagIconPropsType = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _props = require('../functions/props');

var _propTypes3 = require('../functions/propTypes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var FlagIconSizeType = _propTypes2.default.oneOf((0, _props.getSizes)());
var FlagIconRotateType = _propTypes2.default.oneOf((0, _props.getRotates)());
var FlagIconFlipType = _propTypes2.default.oneOf((0, _props.getFlips)());

var makeFlagIconCodeType = function makeFlagIconCodeType(codes) {
  return _propTypes2.default.oneOf(codes);
};

var makeFlagIconClassesObject = function makeFlagIconClassesObject(codes) {
  return {
    code: makeFlagIconCodeType(codes).isRequired,
    size: FlagIconSizeType,
    squared: _propTypes2.default.bool,
    rotate: FlagIconRotateType,
    flip: FlagIconFlipType,
    className: _propTypes2.default.string,
    styleName: _propTypes2.default.string
  };
};

var makeFlagIconPropsTypeObject = function makeFlagIconPropsTypeObject(codes) {
  return _extends({}, makeFlagIconClassesObject(codes), {
    children: _propTypes2.default.element,
    Component: _propTypes2.default.string
  });
};

var MakeFlagIconPropsType = exports.MakeFlagIconPropsType = function MakeFlagIconPropsType(codes) {
  return (0, _propTypes3.AddExactValidator)(makeFlagIconPropsTypeObject(codes));
};

var flagIconOptionsType = {
  customCodes: _propTypes2.default.object,
  themeStyles: _propTypes2.default.object,
  useCssModules: _propTypes2.default.bool
};

var MakeFlagIconOptionsPropType = exports.MakeFlagIconOptionsPropType = function MakeFlagIconOptionsPropType() {
  return (0, _propTypes3.AddExactValidator)((0, _propTypes3.AddThemeStylesValidator)(flagIconOptionsType));
};